%----
% Copyright (C) 1996, Gregor Meyer, FernUniversitaet Hagen, Germany.
% This file is part of the system 'Typical'.
% See the file LICENSE for conditions of distribution and use.
%----
%:- multifile (subtype)/1, (suptype)/1, (type)/1, (pred)/1, (type_import)/1, (local)/1.
















:- ensure_loaded(typeops).

:- module_interface(cllib).

:- import(prolog_types).

%-------
:- pred value_var(top).
value_var('$VAR'(_)).   % produced by numbervars/3  (SICStus)
%value_var(v(_)).


%-------
% tinf_diag(_) 
%   tinf_diag may be asserted during the process of parsing and 
%   analysing a clause. It is used in tinf.pl in order to
%   find ount if more error analysis is needed on some 
%   type-inconsistent clause or not.
%   e.g. in decl.pl tinf_diag(error_found) may be asserted.
:- pred tinf_diag(top).
:- dynamic tinf_diag/1.


%-------
% gen_list(L,LV) :-
%       L = any (closed) list
%       LV = a list with same length as L
%            (containing new logical variables if LV was var)
%
:- pred gen_list(list(_),list(_)).
%
gen_list([],[]).
gen_list([_|L],[_Var|LV]) :-
        gen_list(L,LV).

%-------
:- pred make_ltype_pairs(list(T),list(T),list(top)).
%
make_ltype_pairs([],[],[]).
make_ltype_pairs([X|Xs],[Y|Ys],[X*Y|XYs]) :-
        make_ltype_pairs(Xs,Ys,XYs).

%-------
:- pred make_type_pairs(list(T),list(T),list(top)).
%
make_type_pairs([],[],[]).
make_type_pairs([X|Xs],[Y|Ys],[X:Y|XYs]) :-
        make_type_pairs(Xs,Ys,XYs).


:- end_interface(cllib).
:- module_body(cllib).
:- end_module(cllib).