%----
% Copyright (C) 1996, Gregor Meyer, FernUniversitaet Hagen, Germany.
% This file is part of the system 'Typical'.
% See the file LICENSE for conditions of distribution and use.
%----
%:- multifile (subtype)/1, (suptype)/1, (type)/1, (pred)/1, (type_import)/1, (local)/1.
















%
% Implementation of predicates declared in lib.pl
%
% This variant is for Quintus Prolog

:- ensure_loaded(typeops).
 
:- module_body(lib).

:- import(prolog_types).
:- import(prolog_misc).

% append is a built-in

:- use_module(library(subsumes),[variant/2]). 

:- use_module(library(basics),[member/2,memberchk/2,nonmember/2]).

:- pred nonmember(T,list(@T)).

non_member(X,L) :- nonmember(X,L).

% deterministic append 
det_append(A,B,AB) :- append(A,B,AB). 

:- use_module(library(lists),[is_list/1,remove_dups/2,same_length/2,reverse/2,last/2,delet/3]).

:- pred remove_dups(list(@T),list(@T)).

remove_duplicates(X,Y) :- remove_dups(X,Y).

:- use_module(library(sets),[subset/2,subtract/3]).

:- end_module(lib).
