%----
% Copyright (C) 1996, Gregor Meyer, FernUniversitaet Hagen, Germany.
% This file is part of the system 'Typical'.
% See the file LICENSE for conditions of distribution and use.
%----
%:- multifile (subtype)/1, (suptype)/1, (type)/1, (pred)/1, (type_import)/1, (local)/1.
















%
% Implementation of predicates declared in lib.pl
%
% This variant is for SICStus Prolog

:- ensure_loaded(typeops).

:- module_body(lib).

:- import(prolog_types).
:- import(prolog_misc).

:- use_module(library(lists),[append/3,last/2,member/2,memberchk/2,is_list/1,remove_duplicates/2,same_length/2,reverse/2,non_member/2,delete/3]).

% SICStus Prolog defines append(), member(), member_chk(), is_list(), 
% remove_duplicates(), same_length() and reverse() in library 'lists'

% deterministic append
det_append(A,B,AB) :- append(A,B,AB).

% subtract(Set1,Set2,Diff)
% Diff consists of all elements from Set1 which are not also in Set2 

subtract([], _, []).
subtract([Element|Residue], Set, Difference) :-
        memberchk(Element, Set), !,
        subtract(Residue, Set, Difference).
subtract([Element|Residue], Set, [Element|Difference]) :-
        subtract(Residue, Set, Difference).
 
variant(A, B) :-
        subsumes_chk(A,B),
        subsumes_chk(B,A).

%-------
% subset( Set1, Set2) :-
%       every member of Set1 is member of Set2

subset([],_).
subset([X|Xs],S) :- 
        member(X,S),
        subset(Xs,S).

:- end_module(lib).
 
